=header
	Program :	Search
	Author  :	H. Piske
	Written :	06.04.01
	Purpose :	File manipulation utility

I keep using 1982 search.exe, however, it's restricted to 8.3 filenames.
I've had faul.c which worked so-and-so until Win2k came along.
Now let's try over, combine the two and use Perl this time.

=history
see search.txt file
=cut

sub echo
{
	local ($file, $find) = @_;
	local ($_, $inc, $len, $first);
	$first = 1;
	open F1, $file or exit print "can't open $file\n";
	{
		print "reading $file into memory ... " if $babble;
		@_ = ();
		$len = $inc = 0;
		while (<F1>)
		{
			push @_, $_;
			last if $inc = $limit[0] < ($len += length $_);
		}
		print $len, " chars", $inc ? " (incomplete)\n" : "\n"
			if $babble;
		if (eval ($find =~ m/^!/
			?	"\@_=grep {!($')} \@_"
			:	"\@_=grep {$find} \@_"))
		{
			print "==== $file\n" if $talk and $first;
			$first = 0;
			print @_;
		}
		redo if $inc;
	}
	close F1;
	return 1;
}
sub find
{
	local ($file, @find) = @_;
	local ($_, $line, $inc);
	open F1, $file or exit print "can't open $file\n";
	$_ = '';
	for (;;)
	{
		print "reading $file into memory ... " if $babble;
		$inc = 0;
		while (defined ($line = <F1>))
		{
			$_ .= $line;
			last if $inc = $limit[0] < length $_;
		}
		print length $_, " chars", $inc ? " (incomplete)\n" : "\n"
			if $babble;
		for $find (@find)
		{
			if ($find =~ m/^!/ and eval $')
			{
				close F1;
				print "$find fails - rejected\n" if $babble;
				return 1;
			}
			elsif ($find and eval $find)
			{
				$find = '';
				close F1, return 0 unless grep /^[^!]/, @find;
			}
		}
		last unless $inc;
		$_ = substr $_, length ($_) - $limit[1];
		s/.*\n//m;
	}
	close F1;
	return 0 unless ($_) = grep /^[^!]/, @find;
	print "$_ fails - rejected\n" if $babble;
	return 1;
}
sub makedir
{
	local ($_) = pathname (shift);
	return if -d;
	return if /[.\\]$/;
	makedir ($_);
	print "mkdir $_\n" if $talk;
	mkdir $_, 0777;
}
sub copy
{
	local ($loc, $target, $source) = @_;
	$target = pathcat ($loc, $target);
	makedir $target;
	print "cp $source to $target\n" if $talk;
	`copy \"$source\" \"$target\"`;
	return 1;
}
sub comp
{
	local $_ = shift;
	return !comp ($', @_) if /^!/;
	$_ = pathcat ($_, shift);
	return 1 unless -f;
	return 0 unless $_[0];
	local ($f1, $f2);
	open F1, ($f1 = $_) or exit print "can't open $_\n";
	open F2, ($_ = shift) or exit print "can't open $_\n";
	print "comp $_ and $f1: " if $babble;
	unless ($_[0])
	{
		binmode F1;
		binmode F2;
	}
	$_ = 1;
	for (;;)
	{
		unless (read F1, $f1, 32768)
		{
			$_ = read F2, $f2, 1;
			last;
		}
		last unless read F2, $f2, 32768;
		next if $f1 eq $f2;
		last unless $_[0];
		$f1 =~ s/\s*/ /g;
		$f2 =~ s/\s*/ /g;
		last if $f1 ne $f2;
	}
	close F1;
	close F2;
	print $_ ? "different\n" : "equal\n" if $babble;
	return $_;
}
sub help
{
	local $_ = $0;
	unless ($help)
	{
		s/\.\S{1,3}$/.txt/;
		open HELP, $_ or exit print "$_ not found." . '

	PLEASE NOTE THAT THIS IS A VIOLATION OF THE FAIR USE
	of my work. Please be so kind and restore the program
	and all of it\'s associated files to the original state
	found in www.fairymails.com/perl/search.zip

	If you found this source file without the text file
	supposed to come along, please contact FairyMail@gmx.net
';
		$help = join '', <HELP>;
		close HELP;
		$help =~ s/^[^\[]*//s;
		$help =~ s/^#.*\n//mg;
	}
	$_ = shift;
	$help =~ /^\[$_.*\n((\n*[^\[\n].*)*)/m or exit print
		/^[^-]/ ? "help topic not found\n" : '
	there\'s something wrong with the help file. This is either
	one of my famous bugs or somebody else messed around with
	the program. In any case please let me know. Thank you.
	FairyMail@gmx.net
';
	if (-t STDOUT && open MORE, "|more")
	{
		print MORE $1;
		close MORE;
		return;
	}
	print $1;
}
$_ = 'Search.pl V 1.0 - (w) 04/01 by H. Piske
usage: PERL SEARCH.PL [options] files [...] [filters] [actions]
    retrieve a list of files and do something with them.
';
unless (@ARGV)
{
	exit unless -t STDOUT;
	print;
	exit help (-brief);
}
@limit = (2e6, 1000);
@nopar = qw(nr nt \ . ; s v debug);
@onepar = @_ = qw(name fname exists comp compa diff diffa find echo);
push @onepar, map $_ = '!' . $_, @_;
push @onepar, qw(line cmd cp);
parse:
while ($par = shift)
{
	unless ($par =~ s!^[-/]!!)
	{
		push @search, $par;
		next;
	}
	$par =~ s/([^=:]+)\s*[=:]?\s*//;
	if (($keyword = lc $1) =~ /^(\?(\w*)|h(elp)?)/)
	{
		$_ = $2 || shift;
		exit help ($_) if $_;
		help (-detail);
		print "available topics:\n", sort map "\t$_\n", $help =~ /^\[([^-]\w*)/mg;
		exit help (-warning);
	}
	for (@nopar)
	{
		if ($_ eq $keyword)
		{
			$opt{$_} = 1;
			next parse;
		}
	}
	for (@onepar)
	{
		if ($_ eq $keyword)
		{
			$par = shift if $par eq '';
			$par = shift if $par =~ /^\s*[=:]\s*$/;
			$par =~ s/^!// || $par =~ s/^/!/ if s/^!//;
			push @{$opt{$_}}, $par;
			next parse;
		}
	}
	if ($keyword =~ /^limit/)
	{
		local $var = $'
	}
	if ($keyword =~ /^mod/)
	{
		local $var = $'
	}
	exit print "invalid keyword /$keyword -- try /help\n";
}
$opt{';'} ||= /;/ for @{$opt{name}}, @{$opt{fname}};
$_ = $opt{'.'} + ($opt{'\\'} << 1);
$all = qw([^\\\\;] [^\\\\] [^;] .)[$_];
$all =~ s/;/\\./ unless $opt{';'};
for (@{$opt{name}}, @{$opt{fname}})
{
	s!/!\\!g;
	s/([\$\@\%.\(\)\{\}\\])/\\$1/g;
	s/(^|[^\[])\^(.)/[^$1]/g;
	s/\?\*|\*\?/$all+/g;
	s/\*/$all*/g;
	s/\?/$all/g;
}
map {$_ = join '|', grep s/(!)?(.*)/$1\\\\$2\$/, split '\|'} @{$opt{name}};
push @{$opt{name}}, map {
	$_ = join '|', grep s/(!)?(.*)/$1^(\\.\\\\)?$2\$/, split '\|'
} @{$opt{fname}};
@search = ('*') unless @search;
for (@{$opt{diff}})
{
	push @{$opt{exists}}, $_ unless /^!/;
	s/^!// || s/^/!/;
	push @{$opt{comp}}, $_;
}
for (@{$opt{diffa}})
{
	push @{$opt{exists}}, $_ unless /^!/;
	s/^!// || s/^/!/;
	push @{$opt{compa}}, $_;
}
sub block
{
	local ($rem, $del, $end, $cnt, $len, $_);
	($rem, $del) = @_;
	$end = $_ = '\\' . $del;
	y/{[(</}])>/
		?	($end = "[$_$end]")
		:	($del = '');
	$cnt = 1;
	$len = 0;
	$_ = $rem;
	while ($cnt)
	{
		return '---' unless /(\\*)($end)/g;
		$cnt += ($2 eq $del) ? 1 : -1 unless length ($1) & 1;
	}
	return pos > 1 ? substr $_, pos : '---';
}
for (@{$opt{rex}}, @{$opt{find}}, @{$opt{echo}})
{
	local ($not, $dbl, $rem, $del);
	if (m<^\s*(!?|\$\s*\w+\s*[=!]~)\s*(m?\s*(/)|m\s*(\W)|(s|y|tr)\s*(\W))>)
	{
		$dbl = $5;
		$rem = block ($', $del = $+);
		if ($dbl)
		{
			if ($del =~ /[\(\[{<]/)
			{
				$rem =~ s/.//;
				$del = $&;
			}
			$rem = block ($rem, $del);
		}
		else
		{
			$rem = '-' if m<^\s*!?\s*m?\s*(.)\1>;
		}
		next if $rem =~ /^[cdegimosx\s]*;?\s*$/;
	}
	exit print "illegal regular expression $_\n"
		if block ($_ . ')', '(') ne '';
	m/^!?/;
	$_ = "$&m($')";
}
%spec = qw(; \n @ ${file} ! ${path} & ${name} # ${base} % ${ext});
$spec = join '', '$', keys %spec;
for (@{$opt{line}}, @{$opt{cmd}})
{
	s/(["\\])/\\$1/g;
	s/([$spec])\1/\\$1/g;
	{} while s/((^|[^\\])(\\\\)*\$)([a-z])/$1\{$+\}/;
	for $spec (keys %spec)
	{
		s/((^|[^\\])(\\\\)*)$spec/$1$spec{$spec}/g;
	}
}
if ($opt{debug})
{
	print "search $_\n" for @search;
	print "wildcard $all\n";
	print "/$_ => $opt{$_}\n" for sort grep !ref $opt{$_}, keys %opt;
	delete $opt{$_} for qw(fname diff diffa);
	for $opt (sort grep ref $opt{$_}, keys %opt)
	{
		print "/$opt $_\n" for @{$opt{$opt}};
	}
	exit;
}
$talk = !$opt{'s'};
$babble = $opt{'v'};
use recurs;
for (@search)
{
	print "collecting $_\n" if $babble;
	@files = $opt{nr} ? glob ($_) : recurs ($_);
file:
	for $file (@files)
	{
		($path, $_) = pathname ($file);
		/(.+)\.([^\s\.]{1,5}$)/ || /(.*)/;
		$base = $1;
		$ext = $2;
		$name = $_;
		$test = $path . '\\' . ($opt{';'} ? "$base;$ext" : $name);
		/^!/ ? ($test =~ m($')i) : ($test !~ m($_)i) and next file
			for @{$opt{name}};
		$file =~ /^(\\\\\w+|.:)?\\?(.*)/;
		$loc = $opt{nt} ? $name : $2;
		comp ($_, $loc) and next file for @{$opt{exists}};
		comp ($_, $loc, $file) and next file for @{$opt{comp}};
		comp ($_, $loc, $file, 1) and next file for @{$opt{compa}};
		($f, $p, $n, $b, $e) = ($file, $path, $name, $base, $ext);
		rex ($_) and next file for @{$opt{rex}};
		find ($file, @_) and next file if @_ = @{$opt{find}};
		$work = print eval qq("$_"), "\n" for @{$opt{line}};
		for (@{$opt{cmd}})
		{
			$cmd = eval qq("$_");
			for (grep $_, split "\n", $cmd)
			{
				print "$_\n" if $babble;
				system $_;
			}
			$work = 1;
		}
		$work = echo ($file, $_) for @{$opt{echo}};
		$work = copy ($_, $loc, $file) for @{$opt{cp}};
		print "$file\n" unless $work;
	}
}
